## pupnp 1.18.0

=== ixml/CMakeLists.txt ===
if(BUILD_TESTING)
	enable_testing()
	add_subdirectory(test)
endif()

set(IXML_SOURCES
	src/attr.c
	src/document.c
	src/element.c
	src/ixml.c
	src/ixmldebug.c
	src/ixmlmembuf.c
	src/ixmlparser.c
	src/namedNodeMap.c
	src/node.c
	src/nodeList.c
)

list(APPEND IXML_HEADERS inc/ixml.h inc/ixmldebug.h)

if(UPNP_BUILD_SHARED)
	add_library(ixml_shared SHARED ${IXML_SOURCES})

	add_library(IXML::Shared ALIAS ixml_shared)

	set_target_properties(
		ixml_shared
		PROPERTIES C_VISIBILITY_PRESET "hidden"
				EXPORT_NAME IXML::Shared
				OUTPUT_NAME ixml
				PUBLIC_HEADER "${IXML_HEADERS}"
				SOVERSION ${IXML_SOVERSION_MAJOR}
				VERSION ${IXML_SOVERSION_STRING}
	)

	target_compile_definitions(
		ixml_shared
		PRIVATE
			$<$<BOOL:${IXML_HAVE_SCRIPTSUPPORT}>:IXML_HAVE_SCRIPTSUPPORT>
		PRIVATE LIBUPNP_EXPORTS
		PUBLIC $<$<BOOL:${MSVC}>:UPNP_USE_MSVCPP>
		PUBLIC $<$<BOOL:${MSVC}>:LIBUPNP_EXPORTS>
		PUBLIC $<$<BOOL:${_LARGE_FILES}>:_LARGE_FILES>
		PUBLIC $<$<BOOL:${_FILE_OFFSET_BITS}>:_FILE_OFFSET_BITS=64>
		PUBLIC $<IF:$<CONFIG:Debug>,DEBUG,NDEBUG>
	)

	target_include_directories(
		ixml_shared
		PRIVATE ${PUPNP_BINARY_DIR}/
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc/>
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/inc/>
		PUBLIC $<BUILD_INTERFACE:${PUPNP_SOURCE_DIR}/upnp/inc/>
	)

	install(
		TARGETS ixml_shared
		EXPORT IXML
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_Development
		INCLUDES
		DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
		COMPONENT UPNP_Development
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_RunTime
			NAMELINK_COMPONENT UPNP_Development
		PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
				COMPONENT UPNP_Development
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
			COMPONENT UPNP_RunTime
	)
endif()

if(UPNP_BUILD_STATIC)
	add_library(ixml_static STATIC ${IXML_SOURCES})

	add_library(IXML::Static ALIAS ixml_static)

	set_target_properties(
		ixml_static
		PROPERTIES C_VISIBILITY_PRESET "hidden"
				EXPORT_NAME IXML::Static
				OUTPUT_NAME ixml${STATIC_POSTFIX}
				PUBLIC_HEADER "${IXML_HEADERS}"
				SOVERSION ${IXML_SOVERSION_MAJOR}
				VERSION ${IXML_SOVERSION_STRING}
	)

	target_compile_definitions(
		ixml_static
		PRIVATE
			$<$<BOOL:${IXML_HAVE_SCRIPTSUPPORT}>:IXML_HAVE_SCRIPTSUPPORT>
		PRIVATE LIBUPNP_EXPORTS
		PUBLIC UPNP_STATIC_LIB
		PUBLIC $<$<BOOL:${MSVC}>:UPNP_USE_MSVCPP>
		PUBLIC $<IF:$<CONFIG:Debug>,DEBUG,NDEBUG>
		PUBLIC $<$<BOOL:${_LARGE_FILES}>:_LARGE_FILES>
		PUBLIC $<$<BOOL:${_FILE_OFFSET_BITS}>:_FILE_OFFSET_BITS=64>
	)

	target_include_directories(
		ixml_static
		PRIVATE ${PUPNP_BINARY_DIR}/
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc/>
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/inc/>
		PUBLIC $<BUILD_INTERFACE:${PUPNP_SOURCE_DIR}/upnp/inc/>
	)

	install(
		TARGETS ixml_static
		EXPORT IXML
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_Development
		INCLUDES
		DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
		COMPONENT UPNP_Development
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_RunTime
			NAMELINK_COMPONENT UPNP_Development
		PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
				COMPONENT UPNP_Development
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
			COMPONENT UPNP_RunTime
	)
endif()

install(EXPORT IXML DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/IXML)

=== upnp/CMakeLists.txt ===
# Only set library prefix with MSVC toolchain
if(MSVC)
	set(WIN_PREFIX "lib")
endif()

if(UPNP_BUILD_SAMPLES)
	add_subdirectory(sample)
endif()

set(UPNP_SOURCES
	src/api/upnpapi.c
	src/api/upnpdebug.c
	src/api/UpnpActionComplete.c
	src/api/UpnpActionRequest.c
	src/api/UpnpDiscovery.c
	src/api/UpnpEvent.c
	src/api/UpnpEventSubscribe.c
	src/api/UpnpExtraHeaders.c
	src/api/UpnpFileInfo.c
	src/api/UpnpStateVarComplete.c
	src/api/UpnpStateVarRequest.c
	src/api/UpnpString.c
	src/api/UpnpSubscriptionRequest.c
	src/genlib/client_table/GenlibClientSubscription.c
	src/genlib/client_table/client_table.c
	src/genlib/miniserver/miniserver.c
	src/genlib/net/sock.c
	src/genlib/net/http/httpparser.c
	src/genlib/net/http/httpreadwrite.c
	src/genlib/net/http/parsetools.c
	src/genlib/net/http/statcodes.c
	src/genlib/net/http/webserver.c
	src/genlib/net/uri/uri.c
	src/genlib/service_table/service_table.c
	src/genlib/util/list.c
	src/genlib/util/membuffer.c
	src/genlib/util/strintmap.c
	src/genlib/util/util.c
	src/threadutil/FreeList.c
	src/threadutil/LinkedList.c
	src/threadutil/ThreadPool.c
	src/threadutil/TimerThread.c
	src/urlconfig/urlconfig.c
)

if(WIN32)
	list (APPEND UPNP_SOURCES
		src/inet_pton.c
	)
endif()

if(UPNP_ENABLE_GENA)
	list(APPEND UPNP_SOURCES src/gena/gena_device.c src/gena/gena_ctrlpt.c
		src/gena/gena_callback2.c
	)
endif()

if(UPNP_ENABLE_SOAP)
	list(APPEND UPNP_SOURCES src/soap/soap_device.c src/soap/soap_ctrlpt.c
		src/soap/soap_common.c
	)
endif()

if(UPNP_ENABLE_SSDP)
	list(
		APPEND
		UPNP_SOURCES
		src/ssdp/SSDPResultData.c
		src/ssdp/SSDPResultDataCallback.c
		src/ssdp/ssdp_device.c
		src/ssdp/ssdp_ctrlpt.c
		src/ssdp/ssdp_server.c
	)
endif()

if(UPNP_ENABLE_GENA OR UPNP_ENABLE_OPTIONAL_SSDP_HEADERS)
	list(APPEND UPNP_SOURCES src/uuid/md5.c src/uuid/sysdep.c
		src/uuid/uuid.c
	)
endif()

list(
	APPEND
	UPNP_HEADERS
	inc/Callback.h
	inc/list.h
	inc/upnp.h
	inc/UpnpActionComplete.h
	inc/UpnpActionRequest.h
	inc/UpnpDiscovery.h
	inc/UpnpEvent.h
	inc/UpnpEventSubscribe.h
	inc/UpnpExtraHeaders.h
	inc/UpnpFileInfo.h
	inc/UpnpGlobal.h
	inc/UpnpInet.h
	inc/UpnpIntTypes.h
	inc/UpnpStateVarComplete.h
	inc/UpnpStateVarRequest.h
	inc/UpnpStdInt.h
	inc/UpnpString.h
	inc/UpnpSubscriptionRequest.h
	inc/UpnpUniStd.h
	${PUPNP_BINARY_DIR}/upnp/inc/upnpconfig.h
)

if(UPNP_ENABLE_HELPER_API_TOOLS)
	list(APPEND UPNP_SOURCES src/api/upnptools.c)

	list(APPEND UPNP_HEADERS inc/upnptools.h)
endif()

if(UPNP_BUILD_SHARED)
	add_library(upnp_shared SHARED ${UPNP_SOURCES})

	add_library(UPNP::Shared ALIAS upnp_shared)

	set_target_properties(
		upnp_shared
		PROPERTIES C_VISIBILITY_PRESET "hidden"
				EXPORT_NAME UPNP::Shared
				OUTPUT_NAME ${WIN_PREFIX}upnp
				PUBLIC_HEADER "${UPNP_HEADERS}"
				SOVERSION ${UPNP_SOVERSION_MAJOR}
				VERSION ${UPNP_SOVERSION_STRING}
	)

	target_compile_definitions(
		upnp_shared
		PRIVATE $<$<CONFIG:Debug>:STATS>
		PRIVATE LIBUPNP_EXPORTS
		PUBLIC $<IF:$<CONFIG:Debug>,DEBUG,NDEBUG>
	)

	target_compile_options(
		upnp_shared
		PRIVATE
			$<$<BOOL:${HAVE_MACRO_PREFIX_MAP}>:-fmacro-prefix-map=${CMAKE_SOURCE_DIR}/=.>
	)

	target_include_directories(
		upnp_shared
		PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src/threadutil/
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc/>
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/inc/>
		PUBLIC $<BUILD_INTERFACE:${PUPNP_BINARY_DIR}/>
		PUBLIC $<BUILD_INTERFACE:${PUPNP_BINARY_DIR}/upnp/inc/>
	)

	target_link_libraries(
		upnp_shared
		PRIVATE $<$<BOOL:${UPNP_ENABLE_OPEN_SSL}>:OpenSSL::SSL>
		PRIVATE $<$<PLATFORM_ID:SunOS>:nsl>
		PRIVATE $<$<PLATFORM_ID:SunOS>:socket>
		PRIVATE $<$<PLATFORM_ID:Windows>:ws2_32>
		PRIVATE $<$<PLATFORM_ID:Windows>:iphlpapi>
		PUBLIC ixml_shared
		PUBLIC Threads::Shared
	)

	install(
		TARGETS upnp_shared
		EXPORT UPNP
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_Development
		INCLUDES
		DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
		COMPONENT UPNP_Development
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_RunTime
			NAMELINK_COMPONENT UPNP_Development
		PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
				COMPONENT UPNP_Development
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
			COMPONENT UPNP_RunTime
	)
endif()

if(UPNP_BUILD_STATIC)
	add_library(upnp_static STATIC ${UPNP_SOURCES})

	add_library(UPNP::Static ALIAS upnp_static)

	set_target_properties(
		upnp_static
		PROPERTIES C_VISIBILITY_PRESET "hidden"
				EXPORT_NAME UPNP::Static
				OUTPUT_NAME ${WIN_PREFIX}upnp${STATIC_POSTFIX}
				PUBLIC_HEADER "${UPNP_HEADERS}"
				SOVERSION ${UPNP_SOVERSION_MAJOR}
				VERSION ${UPNP_SOVERSION_STRING}
	)

	target_compile_definitions(
		upnp_static
		PRIVATE UPNP_STATIC_LIB
		PRIVATE LIBUPNP_EXPORTS
		PRIVATE $<$<CONFIG:Debug>:STATS>
		PUBLIC $<IF:$<CONFIG:Debug>,DEBUG,NDEBUG>
	)

	target_compile_options(
		upnp_static
		PRIVATE
			$<$<BOOL:${HAVE_MACRO_PREFIX_MAP}>:-fmacro-prefix-map=${CMAKE_SOURCE_DIR}/=.>
	)

	target_include_directories(
		upnp_static
		PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src/threadutil/
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc/>
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/inc/>
		PUBLIC $<BUILD_INTERFACE:${PUPNP_BINARY_DIR}/>
		PUBLIC $<BUILD_INTERFACE:${PUPNP_BINARY_DIR}/upnp/inc/>
	)

	target_link_libraries(
		upnp_static
		PRIVATE $<$<BOOL:${UPNP_ENABLE_OPEN_SSL}>:OpenSSL::SSL>
		PRIVATE $<$<PLATFORM_ID:SunOS>:nsl>
		PRIVATE $<$<PLATFORM_ID:SunOS>:socket>
		PRIVATE $<$<PLATFORM_ID:Windows>:ws2_32>
		PRIVATE $<$<PLATFORM_ID:Windows>:iphlpapi>
		PUBLIC ixml_static
		PUBLIC Threads::Static
	)

	install(
		TARGETS upnp_static
		EXPORT UPNP
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_Development
		INCLUDES
		DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
		COMPONENT UPNP_Development
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_RunTime
			NAMELINK_COMPONENT UPNP_Development
		PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
				COMPONENT UPNP_Development
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
			COMPONENT UPNP_RunTime
	)
endif()

install(EXPORT UPNP DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/UPNP)

if(BUILD_TESTING)
	enable_testing()
	add_subdirectory(test)
endif()

=== ixml/test/CMakeLists.txt ===
file(GLOB XML_FILES ${CMAKE_CURRENT_SOURCE_DIR}/testdata/*.xml)

ixml_add_unit_test(test-ixml test_document.c ${XML_FILES})
ixml_add_unit_test(test-ixml-poc-gh-506 poc_gh_506.c "")

=== debian/changelog ===
pupnp (1:1.18.0-1) experimental; urgency=medium

  * New upstream version 1.18.0
  * SONAME bump: libupnp17 -> libupnp20
  * debian/copyright:
    - Update copyright years
    - Remove FSF address
  * debian/control:
    - Bump Standards-Version
    - Drop RRR: no
    - Drop Priority: optional

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 11 Feb 2026 18:57:44 +0100

=== debian/control ===
Source: pupnp
Section: net
Homepage: https://pupnp.github.io/pupnp/
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Sebastian Ramacher <sramacher@debian.org>
Build-Depends:
 dpkg-dev (>= 1.22.5),
 debhelper-compat (= 13),
 cmake,
 ninja-build,
Build-Depends-Indep:
 doxygen,
 graphviz,
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/multimedia-team/pupnp
Vcs-Git: https://salsa.debian.org/multimedia-team/pupnp.git

Package: libupnp-dev
Architecture: any
Section: libdevel
Depends:
 libixml11t64 (= ${binary:Version}),
 libupnp20 (= ${binary:Version}),
 ${misc:Depends}
Suggests: libupnp-doc
Description: Portable SDK for UPnP Devices, version 1.14 (development files)
 The Portable SDK for UPnP Devices (libupnp) provides developers with an
 API and open source code for building control points, devices, and
 bridges that are compliant with Version 1.0 of the Universal Plug and
 Play Device Architecture Specification - see http://www.upnp.org/ for
 specifications.
 .
 This package contains the header files, documentation and
 debug versions of libraries needed for development of programs using
 uPnP.

Package: libupnp20
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Portable SDK for UPnP Devices (shared library)
 The Portable SDK for UPnP Devices (libupnp) provides developers with an
 API and open source code for building control points, devices, and
 bridges that are compliant with Version 1.0 of the Universal Plug and
 Play Device Architecture Specification - see http://www.upnp.org/ for
 specifications.
 .
 This package contains the runtime library for uPnP.

Package: libixml11t64
Provides: ${t64:Provides}
Replaces: libixml11
Breaks: libixml11 (<< ${source:Version})
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Portable SDK for UPnP Devices (ixml shared library)
 The Portable SDK for UPnP Devices (libupnp) provides developers with an
 API and open source code for building control points, devices, and
 bridges that are compliant with Version 1.0 of the Universal Plug and
 Play Device Architecture Specification - see http://www.upnp.org/ for
 specifications.
 .
 This package contains the runtime libraries for the Linux DOM2
 XML Parser (IXML).

Package: libupnp-doc
Multi-Arch: foreign
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Documentation for the Portable SDK for UPnP Devices
 The Portable SDK for UPnP Devices (libupnp) provides developers with an
 API and open source code for building control points, devices, and
 bridges that are compliant with Version 1.0 of the Universal Plug and
 Play Device Architecture Specification - see http://www.upnp.org/ for
 specifications.
 .
 This package contains the HTML documentation for the libupnp library
 in /usr/share/doc/libupnp-dev/

=== debian/watch ===
Version: 5

Template: GitHub
Owner: pupnp
Project: pupnp
